/*
 * 
 * Created by D.Gass
 * 
 * Email: dan01@mail.info-suivi.top
 * 
 * june 2022
 * 
 Based also on  BasicHTTPClient.ino provided automatically whith Arduino esp8266 features
*/
// SDS011 def section =====================
// In the library manager, search for "SDS011" and install the "SDS011 sensor Library" by R. Zschiegner.
#include <SDS011.h>
float p10, p25;
int err;
SDS011 my_sds;
// DHT def section =====================
#include "DHT.h"
#define DHTTYPE DHT22   // DHT 22
uint8_t DHT1Pin = 13; 
uint8_t DHT2Pin = 14; 
DHT dht1(DHT1Pin, DHTTYPE);
DHT dht2(DHT2Pin, DHTTYPE);
float Temperature;
float Humidity;
// Arduino def section =====================
#include <Arduino.h>
// WiFi and http def section =======================
#include <ESP8266WiFi.h>
#include <ESP8266HTTPClient.h>
// PCF8574 def section =======================
#include "PCF8574.h"
PCF8574 PCF_38(0x38);  // add switches to lines  (used as input)
// Variables section =======================
const int DonePin = 0;                           // = pin D3 = GPIO0  connected to TPL5110 DONE
const int ResetCounter = 15;                     // = pin D8 = GPIO15 connected to reset CD4040
// Domotic
String IpDestAddr = "http://192.168.1.235:8080";
String RainHttp =    IpDestAddr + "/json.htm?type=command&param=udevice&idx=68&nvalue=0&svalue=";
String RainTotHttp = IpDestAddr + "/json.htm?type=command&param=udevice&idx=89&nvalue=0&svalue=";
String VoltHttp =    IpDestAddr + "/json.htm?type=command&param=udevice&idx=90&nvalue=0&svalue=";
String RssiHttp =    IpDestAddr + "/json.htm?type=command&param=udevice&idx=76&nvalue=0&svalue=";
String TempHumHttp = IpDestAddr + "/json.htm?type=command&param=udevice&idx=83&nvalue=0&svalue=";
String TempHumHttp2 = IpDestAddr + "/json.htm?type=command&param=udevice&idx=87&nvalue=0&svalue=";
String Pm10Http =    IpDestAddr + "/json.htm?type=command&param=udevice&idx=63&nvalue=0&svalue=";
String Pm25Http =    IpDestAddr + "/json.htm?type=command&param=udevice&idx=62&nvalue=0&svalue=";
String ConnHttp =    IpDestAddr + "/json.htm?type=command&param=udevice&idx=88&nvalue=0&svalue=";
String TimeHttp =    "http://worldtimeapi.org/api/timezone/Europe/Paris";
String HttpReq, HttpReturnString;
uint8_t PulseValue;
int lp = 0;
// setup  ====================================
void setup() {
  // pin postionning
  pinMode(DonePin,OUTPUT);
  digitalWrite(DonePin, HIGH);
  pinMode(ResetCounter,OUTPUT);
  digitalWrite(ResetCounter, LOW);
  Serial.begin(115200);
  // Serial.setDebugOutput(true);
  Serial.println();
  // DHT start
  dht1.begin();
  dht2.begin();
  // SdS start
  my_sds.begin(12,14); // ports RX=GPIO12 (D6), TX=GPIO14 (D5)
  // PCF8574 start
  PCF_38.begin();
  // Wifi start connection
  WiFi.begin("SSid", "PWD"); //<===== 
  while(WiFi.status() != WL_CONNECTED)
     {
     Serial.print(".");
     delay(500);
     lp++;
     if(lp >= 120){ break;  }
     } 
  Serial.print("WiFi IP address: "); Serial.println(WiFi.localIP());
  // Sends out WiFi signal strength
  HttpReq = RssiHttp + String(WiFi.RSSI());
  SendHttp (HttpReq);
  // Sends time to connect
  HttpReq = ConnHttp + String(lp*0.5);
  SendHttp (HttpReq);
  // Ready to work
}
// void  ====================================
void loop() {
  Serial.println("Ready to work ================================>");
  delay(1000); 
  Processing_PCF8574(); // rain level
  Processing_BATLOW();  // battery low test
  Processing_DHT11_1(); // temp and humidity external
  Processing_DHT11_2(); // temp and humidity internal
  Processing_SDS011();  // air quality
  // test time to reset CD4040 counter
  TestCurrentTime(); 
  // put in sleep mode via TPL5110
  digitalWrite(DonePin, LOW);
  delay(20000); // for testing purpose when connected on USB
}
