void SendHttp (String url)
{
    Serial.println(url);
    WiFiClient client;

    HTTPClient http;

    Serial.print("[HTTP] begin...\n");
    // send HTTP 
    if (http.begin(client, url)) 
      {  
      // start connection and send HTTP header
      int httpCode = http.GET();
      // httpCode will be negative on error
      if (httpCode > 0) 
        {
        // HTTP header has been send and Server response header has been handled
        Serial.printf("[HTTP] GET... code: %d\n", httpCode);
        // file found at server
        if (httpCode == HTTP_CODE_OK || httpCode == HTTP_CODE_MOVED_PERMANENTLY) 
        {
          HttpReturnString = http.getString();
          Serial.println(HttpReturnString);
        }
        } else 
        {
          Serial.printf("[HTTP] GET... failed, error: %s\n", http.errorToString(httpCode).c_str());
        }
      http.end();
     } else {
      Serial.printf("[HTTP} Unable to connect\n");
    } 
}
void TestCurrentTime() 
  {
  // read current time  from internet    
  SendHttp (TimeHttp);
  int indx01 = HttpReturnString.indexOf("datetime") + 22;
  String CurrentTimeString = HttpReturnString.substring(indx01,indx01 + 2) + HttpReturnString.substring(indx01 + 3, indx01 + 5);
  float CurrentTimeFloat = CurrentTimeString.toFloat();
  Serial.println(CurrentTimeString);
  if ((CurrentTimeFloat > 2326))
  {
    HttpReq = RainTotHttp + PulseValue;
    SendHttp (HttpReq);
    digitalWrite(ResetCounter, LOW);
    digitalWrite(ResetCounter, HIGH);
    Serial.println("Time over"); 
    delay(1000);    
  }
}
void Processing_PCF8574() 
{
  // read PCF8574 (rain level) ============== 
  // 1 pulse = 1.3mL of water. Collector surface = 25.8cm2 => 0.246mm of water per pulse (0.0097ich)
  PulseValue = PCF_38.read8();
  Serial.print("Number of pulses: "); Serial.println(PulseValue);
  HttpReq = RainHttp + String(PulseValue*0.246);
  SendHttp (HttpReq);
  // 1 pulse = 0.243L/m2 of water. Collector surface = 1m2 => 0.243L of water per pulse (1.3/0.00528)
  HttpReq = RainTotHttp + String(PulseValue*0.243);
  SendHttp (HttpReq);
}
void Processing_BATLOW()
{
  // read the voltage level on analog pin ============
  int val1 = analogRead(A0);
  float val2 = (val1 / 1023.0) * 5;
  if (val2 > 3) {HttpReq = VoltHttp + String(0); }
  else { HttpReq = VoltHttp + String(1); }
  SendHttp (HttpReq);
}  
void Processing_DHT11_1()
{
  // DHT =====================================
  delay(1000);
  Temperature = dht1.readTemperature(); // Gets the values of the temperature
  Humidity = dht1.readHumidity(); // Gets the values of the humidity 
  Serial.print("DHT Temperature: "); Serial.println(Temperature);     
  Serial.print("DHT Humidity: "); Serial.println(Humidity);
  HttpReq = TempHumHttp + String(Temperature) + ";" + String(Humidity) + ";0";
  SendHttp (HttpReq);
}
void Processing_DHT11_2()
{
  // DHT =====================================
  delay(1000);
  Temperature = dht2.readTemperature(); // Gets the values of the temperature
  Humidity = dht2.readHumidity(); // Gets the values of the humidity 
  Serial.print("DHT Temperature: "); Serial.println(Temperature);     
  Serial.print("DHT Humidity: "); Serial.println(Humidity);
  HttpReq = TempHumHttp2 + String(Temperature) + ";" + String(Humidity) + ";0";
  SendHttp (HttpReq);
}
void Processing_SDS011()
{
  // SDS011 read 
  err = my_sds.read(&p25, &p10);
  if (!err) {
    Serial.println("P2.5: " + String(p25));
    Serial.println("P10:  " + String(p10));
    HttpReq = Pm25Http + String(p25);
    SendHttp (HttpReq);
    HttpReq = Pm10Http + String(p10);
    SendHttp (HttpReq);
  } 
}
